// Exactly like the subtract example, except using metric
// stitching
function run() {
    // for each input agent, compute a calculated metric named 
    // "JavaScript:Bytes Remaining" and stitch it into that
    // agent's metric stream.  The calculated metric
    // will lag 15 seconds behind its source data but 
    // the calculated metric will appear to "come from" its agent
    var i=0;
    var agent2remainingBytes = {};
    for(i=0; i < bindings.length; i++) {
        var metric = bindings[i].ESEAttribute.attributeURL;
        var agent = bindings[i].ESEProcess.processURL;
        var value = bindings[i].timeslicedValue.value;
        // set to 0 if we haven't seen this agent yet
        if (agent2remainingBytes[agent] == null) {
            agent2remainingBytes[agent] = 0;
        }
        // somewhat hacky way to subtract, but I can't determine
        // the order in which I'll see data.
        if (metric == "GC Heap:Bytes Total") {
            agent2remainingBytes[agent] +=  value;
        } else {
            agent2remainingBytes[agent] -=  value;
        }
    }
    // now iterate found agents and report calculated metrics
    for (var agent in agent2remainingBytes) {
        var metricName = "JavaScript:Remaining Bytes";
        var value = agent2remainingBytes[agent];
        // "stitcher" is a magic global variable that enables
        // metric stitching - you can get a DataAccumulator factory
        // per agent with either the ESEProcess or a String full agent
        // name.  Then, accumulators produced on that Factory will
        // have their metrics stitched into the real agent's
        // data stream
        stitcher.getDataAccumulatorFactory(agent).getLongFluctuatingCounterDataAccumulator(
            metricName).ILongCounterDataAccumulator_setValue(value);        
    }

}

function getAgentRegex() {
    return ".*";
}
function getMetricRegex() {
    return "GC Heap.*";
}
